virt-what.in: make option processing portable
[virt-what.git] / virt-what.in
index 0979c50..f2c0b90 100644 (file)
@@ -1,4 +1,4 @@
-#!/bin/bash -
+#!/bin/sh -
 # @configure_input@
 # Copyright (C) 2008-2011 Red Hat Inc.
 #
 
 # 'virt-what' tries to detect the type of virtualization being
 # used (or none at all if we're running on bare-metal).  It prints
-# out one of more lines each being a 'fact' about the virtualization.
+# out one or more lines each being a 'fact' about the virtualization.
 #
 # Please see also the manual page virt-what(1).
 # This script should be run as root.
 #
 # The following resources were useful in writing this script:
-# . http://www.dmo.ca/blog/20080530151107
+# . http://dmo.ca/blog/detecting-virtualization-on-linux/
+
+# Do not allow unset variables, and set defaults.
+set -u
+root=''
+skip_qemu_kvm=false
 
 VERSION="@VERSION@"
 
-function fail {
-    echo "virt-what: $1"
+have_cpuinfo() {
+    test -e "${root}/proc/cpuinfo"
+}
+
+fail() {
+    echo "virt-what: $1" >&2
     exit 1
 }
 
-function usage {
+usage() {
     echo "virt-what [options]"
     echo "Options:"
     echo "  --help          Display this help"
@@ -42,47 +51,58 @@ function usage {
 }
 
 # Handle the command line arguments, if any.
-
-TEMP=`getopt -o v --long help --long version --long test-root: -n 'virt-what' -- "$@"`
-if [ $? != 0 ]; then exit 1; fi
-eval set -- "$TEMP"
-
-while true; do
+while test $# -gt 0; do
     case "$1" in
        --help) usage ;;
-        --test-root)
+        --test-root=*)
             # Deliberately undocumented: used for 'make check'.
-            root="$2"
-            shift 2
+            root=$(echo "$1" | sed 's/.*=//')
+            shift 1
+            test -z "$root" && fail "--test-root option requires a value"
             ;;
-       -v|--version) echo $VERSION; exit 0 ;;
+       -v|--version) echo "$VERSION"; exit 0 ;;
        --) shift; break ;;
-       *) fail "internal error ($1)" ;;
+       *) fail "unrecognized option '$1'";;
     esac
 done
+test $# -gt 0 && fail "extra operand '$1'"
 
 # Add /sbin and /usr/sbin to the path so we can find system
-# binaries like dmicode.
+# binaries like dmidecode.
 # Add /usr/libexec to the path so we can find the helper binary.
 prefix=@prefix@
 exec_prefix=@exec_prefix@
-PATH=$root@libexecdir@:$root/sbin:$root/usr/sbin:$PATH
+PATH="${root}@libexecdir@:${root}/sbin:${root}/usr/sbin:${PATH}"
 
 # Check we're running as root.
+EFFUID=$(id -u) || fail "failed to get current user id"
 
-uid=`id -u`
-if [ "$uid" != 0 ]; then
+if [ "x$root" = "x" ] && [ "$EFFUID" -ne 0 ]; then
     fail "this script must be run as root"
 fi
 
+# Try to locate the CPU-ID helper program
+CPUID_HELPER=$(which virt-what-cpuid-helper 2>/dev/null)
+if [ -z "$CPUID_HELPER" ] ; then
+    fail "virt-what-cpuid-helper program not found in \$PATH"
+fi
+
 # Many fullvirt hypervisors give an indication through CPUID.  Use the
 # helper program to get this information.
 
-cpuid=`virt-what-cpuid-helper`
+cpuid=$(virt-what-cpuid-helper)
 
 # Check for various products in the BIOS information.
+# Note that dmidecode doesn't exist on non-PC architectures.  On these,
+# this will return an error which is ignored (error message redirected
+# into $dmi variable).
 
-dmi=`LANG=C dmidecode 2>&1`
+dmi=$(LANG=C dmidecode 2>&1)
+
+# Architecture.
+# Note for the purpose of testing, we only call uname with -p option.
+
+arch=$(uname -p)
 
 # Check for VMware.
 # cpuid check added by Chetan Loke.
@@ -100,8 +120,10 @@ if [ "$cpuid" = "Microsoft Hv" ]; then
 fi
 
 # Check for VirtualPC.
-
-if echo "$dmi" | grep -q 'Manufacturer: Microsoft Corporation'; then
+# The negative check for cpuid is to distinguish this from Hyper-V
+# which also has the same manufacturer string in the SM-BIOS data.
+if [ "$cpuid" != "Microsoft Hv" ] &&
+    echo "$dmi" | grep -q 'Manufacturer: Microsoft Corporation'; then
     echo virtualpc
 fi
 
@@ -117,69 +139,127 @@ fi
 # container)
 # /proc/bc - exists on node, but not inside container.
 
-if [ -d $root/proc/vz -a ! -d $root/proc/bc ]; then
+if [ -d "${root}/proc/vz" -a ! -d "${root}/proc/bc" ]; then
     echo openvz
 fi
 
+# Check for LXC containers
+# http://www.freedesktop.org/wiki/Software/systemd/ContainerInterface
+# Added by Marc Fournier
+
+if [ -e "${root}/proc/1/environ" ] &&
+    cat "${root}/proc/1/environ" | tr '\000' '\n' | grep -Eiq '^container='; then
+    echo lxc
+fi
+
 # Check for Linux-VServer
-if cat $root/proc/self/status | grep -q "VxID: [0-9]*"; then
+if test -e "${root}/proc/self/status" \
+   && cat "${root}/proc/self/status" | grep -q "VxID: [0-9]*"; then
     echo linux_vserver
+    if grep -q "VxID: 0$" "${root}/proc/self/status"; then
+        echo linux_vserver-host
+    else
+        echo linux_vserver-guest
+    fi
 fi
 
 # Check for UML.
 # Added by Laurent LĂ©onard.
-if grep -q 'UML' $root/proc/cpuinfo; then
+if have_cpuinfo && grep -q 'UML' "${root}/proc/cpuinfo"; then
     echo uml
 fi
 
 # Check for IBM PowerVM Lx86 Linux/x86 emulator.
-if grep -q '^vendor_id.*PowerVM Lx86' $root/proc/cpuinfo; then
+if have_cpuinfo && grep -q '^vendor_id.*PowerVM Lx86' "${root}/proc/cpuinfo"
+then
     echo powervm_lx86
 fi
 
 # Check for Hitachi Virtualization Manager (HVM) Virtage logical partitioning.
 if echo "$dmi" | grep -q 'Manufacturer.*HITACHI' &&
-   echo "$dmi" | grep -q 'Product.*HVM LPAR'; then
+   echo "$dmi" | grep -q 'Product.* LPAR'; then
     echo virtage
 fi
 
-# Check for IBM SystemZ (z/VM, not tested whether this applies to Linux
-# installed directly into an LPAR, we may need a separate test).
-if grep -q '^vendor_id.*IBM/S390' $root/proc/cpuinfo; then
-    echo zvm
+# Check for IBM SystemZ.
+if have_cpuinfo && grep -q '^vendor_id.*IBM/S390' "${root}/proc/cpuinfo"; then
+    echo ibm_systemz
+    if [ -f "${root}/proc/sysinfo" ]; then
+        if grep -q 'VM.*Control Program.*z/VM' "${root}/proc/sysinfo"; then
+            echo ibm_systemz-zvm
+        elif grep -q '^LPAR' "${root}/proc/sysinfo"; then
+            echo ibm_systemz-lpar
+        else
+            # This is unlikely to be correct.
+            echo ibm_systemz-direct
+        fi
+    fi
+fi
+
+# Check for Parallels.
+if echo "$dmi" | grep -q 'Vendor: Parallels'; then
+    echo parallels
+    skip_qemu_kvm=true
 fi
 
 # Check for Xen.
 
 if [ "$cpuid" = "XenVMMXenVMM" ]; then
     echo xen; echo xen-hvm
-    is_xen=1
-elif [ -f $root/proc/xen/capabilities ]; then
+    skip_qemu_kvm=true
+elif [ -d "${root}/proc/xen" ]; then
     echo xen
-    if grep -q "control_d" $root/proc/xen/capabilities; then
+    if grep -q "control_d" "${root}/proc/xen/capabilities" 2>/dev/null; then
         echo xen-dom0
     else
         echo xen-domU
     fi
-    is_xen=1
-elif [ -d $root/proc/xen ]; then
-    # This directory can be present when Xen paravirt drivers are
-    # installed, even on baremetal.  Don't confuse people by
-    # printing anything.
-    :
+    skip_qemu_kvm=true
+elif [ -f "${root}/sys/hypervisor/type" ] &&
+    grep -q "xen" "${root}/sys/hypervisor/type"; then
+    # Ordinary kernel with pv_ops.  There does not seem to be
+    # enough information at present to tell whether this is dom0
+    # or domU.  XXX
+    echo xen
+elif [ "$arch" = "ia64" ]; then
+    if [ -d "${root}/sys/bus/xen" -a ! -d "${root}/sys/bus/xen-backend" ]; then
+        # PV-on-HVM drivers installed in a Xen guest.
+        echo xen
+        echo xen-hvm
+    else
+        # There is no virt leaf on IA64 HVM.  This is a last-ditch
+        # attempt to detect something is virtualized by using a
+        # timing attack.
+        virt-what-ia64-xen-rdtsc-test > /dev/null 2>&1
+        case "$?" in
+            0) ;; # not virtual
+            1) # Could be some sort of virt, or could just be a bit slow.
+                echo virt
+        esac
+    fi
 fi
 
 # Check for QEMU/KVM.
+#
+# Parallels exports KVMKVMKVM leaf, so skip this test if we've already
+# seen that it's Parallels.  Xen uses QEMU as the device model, so
+# skip this test if we know it is Xen.
 
-if [ ! "$is_xen" ]; then
-    # Disable this test if we know this is Xen already, because Xen
-    # uses QEMU for its device model.
-
-    if grep -q 'QEMU' $root/proc/cpuinfo; then
-       if [ "$cpuid" = "KVMKVMKVM" ]; then
-           echo kvm
-       else
+if ! "$skip_qemu_kvm"; then
+    if [ "$cpuid" = "KVMKVMKVM" ]; then
+       echo kvm
+    else
+        # XXX This is known to fail for qemu with the explicit -cpu
+        # option, since /proc/cpuinfo will not contain the QEMU
+        # string.  The long term fix for this would be to export
+        # another CPUID leaf for non-accelerated qemu.
+        if grep -q 'QEMU' "${root}/proc/cpuinfo"; then
            echo qemu
        fi
     fi
 fi
+
+# Check for Docker.
+if [ -f "${root}/.dockerinit" ]; then
+       echo docker
+fi